<template>
  <view class="c-card">
    <view class="search">
      <u-search
        placeholder="请输入供应商分类"
        v-model="state.name"
        :showAction="false"
        :bgColor="'#fff'"
        :borderColor="'rgba(0, 0, 0, 0.1)'"
        :placeholderColor="'#C1C1C1'"
        @search="handleSearch()"
      ></u-search>
      <view class="btn" @click="add"> 新增 </view>
    </view>
    <page-view
      @loadList="
        (v) => {
          getList(v);
        }
      "
      :noMoreData="pageList.noMoreData"
    >
      <view class="box">
        <view v-for="(item, index) in pageList.list" :key="index">
          <view>
            <view>{{ item.name }}</view>
          </view>
          <view class="op-box">
            <view class="btn" @click="edit(item)"> 编辑 </view>
            <view class="btn" @click="deleteType(item)"> 删除 </view>
          </view>
        </view>
      </view>
    </page-view>
  </view>
</template>
<script setup lang="ts">
import { StockCardApi, SupplierApi } from "@/services";
import PageView from "@/components/PageView/index.vue";

const keyword = ref("");

const state = reactive<any>({
  name: "",
});
const pageList: PageResult<StockCard> = reactive({
  noMoreData: false,
  total: 0,
  list: [],
  pageNum: 1,
  pageSize: 10,
});
const add = () => {
  uni.navigateTo({
    url: "/pagesApp/components/addSupplierType", // 要跳转到的页面路径
  });
};
const edit = (item: any) => {
  uni.navigateTo({
    url:
      "/pagesApp/components/addSupplierType?title=编辑供应商分类&item=" +
      JSON.stringify(item), // 要跳转到的页面路径
  });
};
const deleteType = (item: any) => {
  SupplierApi.updateSupplierType({ isDeleted: true, id: item.id }).then(
    (res) => {
      if (res.code === 200) {
        getList();
      }
    }
  );
};
const handleSearch = () => {
  getList();
};
const getList = (v?: boolean) => {
  if (v) {
    if (Math.ceil(pageList.total / pageList.pageSize) > pageList.pageNum) {
      pageList.pageNum++;
      if ( Math.ceil(pageList.total / pageList.pageSize) <=  pageList.pageNum) {
        pageList.noMoreData = true
      }
    } else {
      pageList.noMoreData = true;
      return;
    }
  }
  let params: any = {
    pageSize: pageList.pageSize,
    pageNum: pageList.pageNum,
    name: state.name,
  };
  if (state.supplierTypeId > -1) {
    params.supplierTypeId = state.supplierTypeId;
  }
  SupplierApi.getSupplierTypePage(params).then((res) => {
    if (res.code === 200) {
      if (res.code === 200) {
        (pageList as any).list = (res.data as any).list;
        pageList.total = (res.data as any).total;
      }
    }
  });
};

onMounted(() => {
  getList();
});
</script>
<style lang="scss" scoped>
.c-card {
  margin: 30rpx 25rpx;
  .search {
    display: flex;
    align-items: center;
    justify-content: space-between;
    .btn {
      background: #00dcee;
      border-radius: 24rpx;
      border: 1px solid #00dcee;
      font-weight: 500;
      font-size: 26rpx;
      color: #ffffff;
      margin-left: 50rpx;
      padding: 6rpx 30rpx;
    }
  }
  .box {
    background: #ffffff;
    box-shadow: 0rpx 0rpx 10rpx 0rpx rgba(5, 68, 37, 0.12);
    border-radius: 13rpx;
    padding: 0rpx 20rpx;
    font-weight: 400;
    font-size: 26rpx;
    color: #000000;
    line-height: 41rpx;
    margin-top: 30rpx;
    > view {
      display: flex;
      align-items: center;
      justify-content: space-between;
      padding: 20rpx 0rpx;
      .op-box {
        display: flex;
        .btn + .btn {
          margin-left: 20rpx;
        }
        .btn {
          background: #ff9d55;
          border-radius: 24rpx;
          font-weight: 500;
          font-size: 26rpx;
          color: #ffffff;
          padding: 6rpx 30rpx;
        }
      }
    }
    > view + view {
      border-top: 1px solid rgba(233, 233, 233, 0.76);
    }
  }
}
</style>
